Module com.io7m.jtensors.core
Package com.io7m.jtensors.core.unparameterized.vectors

## Class Vectors4F

- java.lang.Object
- - com.io7m.jtensors.core.unparameterized.vectors.Vectors4F

-     public final class Vectors4F
      extends Object

  Functions over `Vector4F` values.

  See "Mathematics for 3D Game Programming and Computer Graphics" 2nd Ed for the derivations of most of the code in this class (ISBN: 1-58450-277-0).

  Since:
    8.0.0

- - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static Vector4F` | `absolute​(Vector4F v0)` | Calculate the absolute of `v0`.
    `static Vector4F` | `add​(Vector4F v0, Vector4F v1)` | Add `v0` to `v1`.
    `static Vector4F` | `addScaled​(Vector4F v0, Vector4F v1, double r)` | Add `v0` to `v1 * r`.
    `static Vector4F` | `clamp​(Vector4F v, Vector4F v_min, Vector4F v_max)` | Clamp the values in `v` by `v_min` and `v_max`.
    `static double` | `distance​(Vector4F v0, Vector4F v1)` | Calculate the distance between `v0` and `v1`.
    `static double` | `dotProduct​(Vector4F v0, Vector4F v1)` | Calculate the scalar product of the vectors `v0` and `v1`.
    `static Vector4F` | `interpolateBilinear​(Vector4F x0y0, Vector4F x1y0, Vector4F x0y1, Vector4F x1y1, double px, double py)` | Bilinearly interpolate between `x0y0`, `x1y0`, `x0y1`, `x1y1`.
    `static Vector4F` | `interpolateLinear​(Vector4F v0, Vector4F v1, double alpha)` | Linearly interpolate between `v0` and `v1` by the amount `alpha`.
    `static double` | `magnitude​(Vector4F v0)` | Calculate the magnitude of the vector `v0`.
    `static double` | `magnitudeSquared​(Vector4F v0)` | Calculate the squared magnitude of the vector `v0`.
    `static Vector4F` | `negate​(Vector4F v)` | Calculate the negation of `v`.
    `static Vector4F` | `normalize​(Vector4F v0)` | Normalize the vector `v0`.
    `static Vector4F` | `scale​(Vector4F v0, double r)` | Scale `v0` by `r`.
    `static Vector4F` | `subtract​(Vector4F v0, Vector4F v1)` | Subtract `v1` from `v0`.
    `static Vector4F` | `zero​()` | The zero vector.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### absolute

          public static Vector4F absolute​(Vector4F v0)

      Calculate the absolute of `v0`.
      Returns:
        `(abs v0.x, abs v0.y, abs v0.z, abs v0.w)` * @param v0 The vector

    - #### add

          public static Vector4F add​(Vector4F v0,
                                     Vector4F v1)

      Add `v0` to `v1`.
      Parameters:
        `v1` - The right vector
      Returns:
        `(v0.x + v1.x, v0.y + v0.y, v0.z + v1.z, v0.w + v1.w)` * @param v0 The left vector

    - #### addScaled

          public static Vector4F addScaled​(Vector4F v0,
                                           Vector4F v1,
                                           double r)

      Add `v0` to `v1 * r`.
      Parameters:
        `v1` - The right vector
        `r` - The scaling value
      Returns:
        `(v0.x + (v1.x * r), v0.y + (v0.y * r), v0.z + (v1.z * r), v0.w + (v1.w * r))` * @param v0 The left vector

    - #### clamp

          public static Vector4F clamp​(Vector4F v,
                                       Vector4F v_min,
                                       Vector4F v_max)

      Clamp the values in `v` by `v_min` and `v_max`.
      Parameters:
        `v_min` - The minimum vector
        `v_max` - The maximum vector
      Returns:
        `(max(min(v.x, v_max.x()), v_min.x()), max(min(v.y, v_max.y()), v_min.y()), max(min(v.z, v_max.z()), v_min.z()), max(min(v.w, v_max.w()), v_min.w()))` * @param v The source vector

    - #### distance

          public static double distance​(Vector4F v0,
                                        Vector4F v1)

      Calculate the distance between `v0` and `v1`.
      Parameters:
        `v1` - The right vector
      Returns:
        The distance between `v0` and `v1`. * @param v0 The left vector

    - #### dotProduct

          public static double dotProduct​(Vector4F v0,
                                          Vector4F v1)

      Calculate the scalar product of the vectors `v0` and `v1`. * @param v0 The left vector
      Parameters:
        `v1` - The right vector
      Returns:
        The scalar product of the two vectors

    - #### interpolateLinear

          public static Vector4F interpolateLinear​(Vector4F v0,
                                                   Vector4F v1,
                                                   double alpha)

      Linearly interpolate between `v0` and `v1` by the amount `alpha`.

      The `alpha` parameter controls the degree of interpolation, such that:

      - `interpolateLinear(v0, v1, 0.0) = v0`
      - `interpolateLinear(v0, v1, 1.0) = v1`
      Parameters:
        `v0` - The left input vector
        `v1` - The right input vector
        `alpha` - The interpolation value in the range `[0, 1]` * @return `((1 - alpha) * v0) + (alpha * v1)`

    - #### interpolateBilinear

          public static Vector4F interpolateBilinear​(Vector4F x0y0,
                                                     Vector4F x1y0,
                                                     Vector4F x0y1,
                                                     Vector4F x1y1,
                                                     double px,
                                                     double py)

      Bilinearly interpolate between `x0y0`, `x1y0`, `x0y1`, `x1y1`.

      The `px` and `py` parameters control the degree of interpolation, such that:

      - `interpolateBilinear(x0y0, x1y0, x0y1, x1y1, 0.0, 0.0) = x0y0`
      - `interpolateBilinear(x0y0, x1y0, x0y1, x1y1, 1.0, 0.0) = x1y0`
      - `interpolateBilinear(x0y0, x1y0, x0y1, x1y1, 0.0, 1.0) = x0y1`
      - `interpolateBilinear(x0y0, x1y0, x0y1, x1y1, 1.0, 1.0) = x1y1`
      Parameters:
        `x0y0` - The top left input vector
        `x1y0` - The top right input vector
        `x0y1` - The bottom left input vector
        `x1y1` - The bottom right input vector
        `px` - The X interpolation value in the range `[0, 1]`
        `py` - The Y interpolation value in the range `[0, 1]` * @return The bilinearly interpolated value

    - #### magnitudeSquared

          public static double magnitudeSquared​(Vector4F v0)

      Calculate the squared magnitude of the vector `v0`. * @param v0 The vector
      Returns:
        The squared magnitude of the vector

    - #### magnitude

          public static double magnitude​(Vector4F v0)

      Calculate the magnitude of the vector `v0`. * @param v0 The vector
      Returns:
        The magnitude of the vector

    - #### negate

          public static Vector4F negate​(Vector4F v)

      Calculate the negation of `v`.
      Returns:
        `(-v.x, -v.y, -v.z, -v.w)` * @param v The vector

    - #### normalize

          public static Vector4F normalize​(Vector4F v0)

      Normalize the vector `v0`.

      If the magnitude of the vector is zero, the function returns `v0`.

      * @param v0 The vector
      Returns:
        A normalized copy of `v0`

    - #### scale

          public static Vector4F scale​(Vector4F v0,
                                       double r)

      Scale `v0` by `r`.
      Parameters:
        `r` - The scaling value
      Returns:
        `(v0.x * r, v0.y * r, v0.z * r, v0.w * r)` * @param v0 The left vector

    - #### subtract

          public static Vector4F subtract​(Vector4F v0,
                                          Vector4F v1)

      Subtract `v1` from `v0`.
      Parameters:
        `v1` - The right vector
      Returns:
        `(v0.x - v1.x, v0.y - v0.y, v0.z - v1.z, v0.w - v1.w)` * @param v0 The left vector

    - #### zero

          public static Vector4F zero​()

      The zero vector.
      Returns:
        `(0, 0, 0, 0)`

Copyright © 2017 <code@io7m.com> http://io7m.com